#include"alloc.h"
#include"fftsg.h"
#include"fftsg2d.h"
#define MAX(x,y) ((x) > (y) ? (x) : (y))



class FDCT{
 public:
  int *ip;
  double *w;
  Image *in;

  FDCT(Image *din){
    
    int i,j,val;
    val=2;
    for(i=2;val<din->sy;i++){
      val *=2;
    }
    int vy = val;
    val=2;
    for(i=2;val<din->sx;i++){
      val *=2;
    }
    int vx = val;
    //printf("%d %d -> %d %d\n",din->sx,din->sy,vx,vy);
    
    
    in = new Image(vx,vy);
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++){
	in->img[i][j] = din->img[din->sy-1][din->sx-1];
      }
    for(i=0;i<din->sy;i++)
      for(j=0;j<din->sx;j++){
	in->img[i][j] = din->img[i][j];
      }
    for(i=0;i<din->sy;i++)
      for(j=in->sx;j<din->sx;j++){
	in->img[i][j] = din->img[i][din->sx-1];
      }
    for(i=in->sy;i<din->sy;i++)
      for(j=0;j<din->sx;j++){
	in->img[i][j] = din->img[din->sy-1][j];
      }
    
    

    int n = MAX(in->sy, in->sx / 2);
    ip = alloc_1d_int(2 + (int) sqrt(n + 0.5));
    n = MAX(in->sy, in->sx) * 3 / 2;
    w = alloc_1d_double(n);
    ip[0] = 0;
    
      
  }
  ~FDCT(){
    free_1d_double(w);
    free_1d_int(ip);
    delete in;
    in=NULL;
  }
  
  void DCT(){
        
    ddct2d(in->sy,in->sx,-1,in->img, NULL,ip,w); 
    

  
  }
  void CopyTo(Image *din){
    int i,j;
    for(i=0;i<din->sy;i++)
      for(j=0;j<din->sx;j++)
	din->img[i][j] = in->img[i][j];
  }
  void CopyFrom(Image *din){
    int i,j;
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++)
	in->img[i][j] = din->img[i][j];
  }
  
  
  

  void InverseDCT(Image *out){
    int i,j;
    
    for (i=0;i<in->sy;i++){
      in->img[i][0] *= 0.5;
    }
    for (j=0;j<in->sx;j++){
      in->img[0][j] *= 0.5;
    }
    ddct2d(in->sy,in->sx,1,in->img, NULL,ip,w);
    double scale = 4.0/((double)(in->sx*in->sy));
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++){
	in->img[i][j]*=scale;
	
      }
    
     for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++){
	out->img[i][j]=in->img[i][j];
	
      }

  }
  void Normalize(Image *out){
    double max,min;
    max=min=out->img[0][0];
    int i,j;
    for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++){
	if(max<out->img[i][j])max=out->img[i][j];
	if(min>out->img[i][j])min=out->img[i][j];
      }
    double range = fabs(max-min);if(range<=0.0)range=1.0;
    
    for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++){
	double val = 255.0*(out->img[i][j]-min)/range;
	if(val<0.0)val=0.0;
	if(val>255.0)val=255.0;
	out->img[i][j] = val;
      }
  }
   void toSpectrum(Image *out){
    int i,j; 
    Image *dummy = new Image(out->sx,out->sy);
    for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++){
	double val = in->img[i][j]*in->img[i][j];
	
	dummy->img[i][j] = log(1.0+val);
	
			     
      }
    Normalize(dummy);
    
    
    for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++)out->img[i][j] = dummy->img[i][j];
    
    
    delete dummy;
    
  }
  
};
#undef MAX
